=== debian/changelog ===
tidy-html5 (2:5.8.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4 (Closes: #1113573)

 -- Timo Röhling <roehling@debian.org>  Sun, 09 Nov 2025 21:20:07 +0100

tidy-html5 (2:5.8.0-2) unstable; urgency=high

  * [CVE-2021-33391]: Fix an upstream issue that allows attacker to
    execute arbitrary code via the -g option of the CleanNode() function
    in gdoc.c.

 -- Ondřej Surý <ondrej@debian.org>  Sun, 27 Apr 2025 12:22:24 +0200

tidy-html5 (2:5.8.0-1) unstable; urgency=medium

  [ Ondřej Surý ]
  * Upload to unstable.
  * Fix d/watch to consider only stable releases
  * Acknowledge orphan by Boyuang (Closes: #1075781); thank for everything
  * Add d/gbp.conf for pristine-tar

  [ Debian Janitor ]
  * Trim trailing whitespace.

 -- Ondřej Surý <ondrej@debian.org>  Sun, 21 Jul 2024 08:39:12 +0200

tidy-html5 (2:5.8.0-1~exp3) experimental; urgency=medium

  * debian/watch: Fix monitoring script.

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Apr 2022 21:44:01 -0400

tidy-html5 (2:5.8.0-1~exp2) experimental; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.

  [ Boyuan Yang ]
  * debian/control: Bump Standards-Version to 4.6.0.
  * debian/control: Fix indent.

 -- Boyuan Yang <byang@debian.org>  Fri, 22 Apr 2022 21:41:05 -0400

tidy-html5 (2:5.8.0-1~exp1) experimental; urgency=medium

  * New upstream stable release.
  * debian/control:
    + Bump SONAME to 58.

 -- Boyuan Yang <byang@debian.org>  Tue, 13 Jul 2021 15:13:45 -0400

tidy-html5 (2:5.7.45-1~exp1) experimental; urgency=medium

  * New upstream interim release as suggested by upstream.
  * debian/control:
    + Bump Standards-Version to 4.5.1.
    + Bump debhelper compat to v13.
  * debian/rules:
    - Drop override for dh_missing, now default in dh13.
    + Use dh13 syntax.
  * debian/patches: Drop all backported patches, merged upstream.
  * debian/libtidy5deb1.symbols: Refresh symbols.

 -- Boyuan Yang <byang@debian.org>  Fri, 26 Mar 2021 13:31:46 -0400

tidy-html5 (2:5.6.0-11) unstable; urgency=medium

  * Rebuild for Ubuntu 20.04 LTS.

  [ Debian Janitor ]
  * Drop no longer supported add-log-mailing-address setting from
    debian/changelog.
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.
  * Update standards version to 4.4.1, no changes needed.

 -- Boyuan Yang <byang@debian.org>  Thu, 02 Jan 2020 13:22:18 -0800

tidy-html5 (2:5.6.0-10) unstable; urgency=medium

  * Rebuild for Debian Buster.

  [ Boyuan Yang ]
  * debian/control:
    + Bump debhelper compat to v12.
    + Bump Standards-Version to 4.3.0.

  [ Viktor Szépe ]
  * debian/control: Fix grammar in package description.

 -- Boyuan Yang <byang@debian.org>  Thu, 28 Feb 2019 16:14:05 -0500

tidy-html5 (2:5.6.0-9) unstable; urgency=medium

  * debian/patches:
    - Drop debian-specific patch to revert issue-679 patch,
      libhtml-tidy-perl has made a new upload to address the
      issue downstream.
    + Cherry-pick upstream patch for upstream issue-697 and
      issue-712 (5.7.10 and 5.7.11 fix).
  * debian/symbols:
    + Add a Build-Depends-Package field as suggested by lintian.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Nov 2018 19:58:50 -0500

tidy-html5 (2:5.6.0-8) unstable; urgency=medium

  * debian/patches:
    + Rearrange patch series to follow upstream commit order.
    + Add a patch to partially revert upstream issue-679 patch to avoid
      an unnecessary breaking behaviour for css-prefix. This fixes an
      autopkgtest regression in libhtml-tidy-perl.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Nov 2018 11:08:12 -0500

tidy-html5 (2:5.6.0-7) unstable; urgency=medium

  * debian/rules:
    + Apply build workaround to fix FTCBFS due to man page generation.
      (Closes: #875429).
  * debian/control:
    + Drop useless ${shlibs:Depends} substitution from libtidy-dev's
      build dependency list.
  * debian/patches:
    + Cherry-pick several upstream trunk patches till tidy-html5 5.7.8.
      (Upstream 5.7.9 changeset is implemented in Debian-specific patch)

 -- Boyuan Yang <byang@debian.org>  Wed, 14 Nov 2018 22:15:20 -0500
