=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/htacg/tidy-html5/tags \
 (?:.*?/)?v?(\d\.[02468]\.\d)@ARCHIVE_EXT@
